      program main
c
      integer nx, ny
      parameter (nx=16,ny=16)
      double precision u(0:nx+1,0:ny+1), unew(0:nx+1,0:ny+1)
      double precision eps, anorm
c-----------------------------------------------------------------------
c  tolerance 
c-----------------------------------------------------------------------
      eps = 1.d-5
c-----------------------------------------------------------------------
c  initialization of u
c-----------------------------------------------------------------------
      do 10 j=0,ny+1
      do 10 i=0,nx+1
         u(i,j) = 0.d0
  10  continue
c-----------------------------------------------------------------------
c  boundary condition
c-----------------------------------------------------------------------
      call bound (nx,ny,u)
c-----------------------------------------------------------------------
c  Gauss iteration
c-----------------------------------------------------------------------
 100  continue
c
      do 30 j=1,ny
      do 30 i=1,nx
         unew(i,j) = 0.25d0*(u(i-1,j)+u(i+1,j)+u(i,j-1)+u(i,j+1))
  30  continue
c-----------------------------------------------------------------------
c  Compute a norm of difference between u and unew
c-----------------------------------------------------------------------
      anorm = 0.d0
      do 40 j=1,ny
      do 40 i=1,nx
         anorm = anorm + abs(unew(i,j)-u(i,j))
  40  continue
c-----------------------------------------------------------------------
c  Update u
c-----------------------------------------------------------------------
      do 50 j=1,ny
      do 50 i=1,nx
         u(i,j) = unew(i,j)
  50  continue
c
      if (anorm .gt. eps) go to 100
c-----------------------------------------------------------------------
c  write output
c-----------------------------------------------------------------------
      open(unit=10,file='u.dat')
c
      do 60 j=1,ny
         write(10,200) (u(i,j),i=1,nx)
  60  continue
c
 200  format(16f5.2)
c-----------------------------------------------------------------------
c  end
c-----------------------------------------------------------------------
      stop
      end
