      subroutine bound2
c-----------------------------------------------------------------------
c  z boundary condition for 3d plane-parallel Parker instability
c-----------------------------------------------------------------------
      implicit none
c
      include 'mpif.h'
      include 'common.inc'
c
      integer i, j, nsize, ndest
c
      real w1(nx,ny,7), w2(nx,ny,7)
c-----------------------------------------------------------------------
c  z-boundary (Periodic)
c-----------------------------------------------------------------------
      nsize = nx*ny*7
c
      do 121 j=1,ny
      do 121 i=1,nx
c
         w1(i,j,1) = q1(i,j,nzp)
         w1(i,j,2) = q2(i,j,nzp)
         w1(i,j,3) = q3(i,j,nzp)
         w1(i,j,4) = q4(i,j,nzp)
         w1(i,j,5) = q5(i,j,nzp)
         w1(i,j,6) = q6(i,j,nzp)
         w1(i,j,7) = q7(i,j,nzp)
c
 121  continue
c
      if (pi.eq.(np-1)) then
         ndest = 0
      else
         ndest = pi+1
      endif
c
      call MPI_SEND (w1,nsize,MPI_REAL,
     &               ndest,pi,MPI_COMM_WORLD,err)
c
      call MPI_BARRIER (MPI_COMM_WORLD,err)
c
      call MPI_RECV (w2,nsize,MPI_REAL,
     &               MPI_ANY_SOURCE,MPI_ANY_TAG,
     &               MPI_COMM_WORLD,status,err)
c
      do 122 j=1,ny
      do 122 i=1,nx
c
         q1(i,j,0) = w2(i,j,1)
         q2(i,j,0) = w2(i,j,2)
         q3(i,j,0) = w2(i,j,3)
         q4(i,j,0) = w2(i,j,4)
         q5(i,j,0) = w2(i,j,5)
         q6(i,j,0) = w2(i,j,6)
         q7(i,j,0) = w2(i,j,7)
c
 122  continue
c
      call MPI_BARRIER (MPI_COMM_WORLD,err)
c
      do 123 j=1,ny
      do 123 i=1,nx
c
         w1(i,j,1) = q1(i,j,1)
         w1(i,j,2) = q2(i,j,1)
         w1(i,j,3) = q3(i,j,1)
         w1(i,j,4) = q4(i,j,1)
         w1(i,j,5) = q5(i,j,1)
         w1(i,j,6) = q6(i,j,1)
         w1(i,j,7) = q7(i,j,1)
c
 123  continue
c
      if (pi.eq.0) then
         ndest = np-1
      else
         ndest = pi-1
      endif
c
      call MPI_SEND (w1,nsize,MPI_REAL,
     &               ndest,pi,MPI_COMM_WORLD,err)
c
      call MPI_BARRIER (MPI_COMM_WORLD,err)
c
      call MPI_RECV (w2,nsize,MPI_REAL,
     &               MPI_ANY_SOURCE,MPI_ANY_TAG,
     &               MPI_COMM_WORLD,status,err)
c
      do 124 j=1,ny
      do 124 i=1,nx
c
         q1(i,j,nzp+1) = w2(i,j,1)
         q2(i,j,nzp+1) = w2(i,j,2)
         q3(i,j,nzp+1) = w2(i,j,3)
         q4(i,j,nzp+1) = w2(i,j,4)
         q5(i,j,nzp+1) = w2(i,j,5)
         q6(i,j,nzp+1) = w2(i,j,6)
         q7(i,j,nzp+1) = w2(i,j,7)
c
 124  continue
c
      call MPI_BARRIER (MPI_COMM_WORLD,err)
c-----------------------------------------------------------------------
c  end
c-----------------------------------------------------------------------
      return
      end
