      program main
c-----------------------------------------------------------------------
c  3D simulations of the Parker instability              
c  Subroutines -- tvd3d
c                 mhdtvd
c                 tstep
c                 bound1
c                 bound2
c                 init
c                 grav
c                 rand
c                 divb
c                 ccfft
c                 out
c                 dump4
c                 dump8
c-----------------------------------------------------------------------
      implicit none
c
      include 'mpif.h'
      include 'common.inc'
c-----------------------------------------------------------------------
c  MPI initialization
c-----------------------------------------------------------------------
      call MPI_INIT (err)
      call MPI_COMM_RANK (MPI_COMM_WORLD,pi,err)
      call MPI_COMM_SIZE (MPI_COMM_WORLD,nps,err)
c
      if (nps.ne.np) then
         write (*,*) 'processor number not equal to pre-defined number'
         stop
      endif
c-----------------------------------------------------------------------
c  files
c-----------------------------------------------------------------------
      if (pi.eq.master) then
         open (unit=10,file='time.dat',
     &         status='unknown',form='formatted',position='append')
         open (unit=11,file='vrms.dat',
     &         status='unknown',form='formatted',position='append')
         open (unit=12,file='energy.dat',
     &         status='unknown',form='formatted',position='append')
      endif
c
      call assign ('assign -I -F f77 -N ieee u:90')
c
      call MPI_BARRIER (MPI_COMM_WORLD,err)
c-----------------------------------------------------------------------
c  initial condition
c-----------------------------------------------------------------------
      call init
      call out
      call dump4
c     call dump8
c
      if (pi.eq.master) then
         write (10,*) nstep, t, dt
      endif
c
      call MPI_BARRIER (MPI_COMM_WORLD,err)
c-----------------------------------------------------------------------
c  MHD steps
c-----------------------------------------------------------------------
 101  continue
c
      call tvd3d
      call divb
c
      nstep = nstep + 1
      t     = t     + dt
      call out
c
      if (pi.eq.master) then
         write (10,*) nstep, t, dt
      endif
c
      if (t.ge.twrite4) then
         nunit4 = nunit4 + 1
         twrite4 = twrite4 + tdelta4
         call dump4
      endif
c
      if (t.ge.twrite8) then
         nunit8 = nunit8+1
         twrite8 = twrite8+tdelta8
         call dump8
      endif
c
      call MPI_BARRIER (MPI_COMM_WORLD,err)
c
      if (t.lt.tend) goto 101
c-----------------------------------------------------------------------
c  MPI finalization
c-----------------------------------------------------------------------
      call MPI_FINALIZE (err)
c-----------------------------------------------------------------------
c  end
c-----------------------------------------------------------------------
      stop
      end
