      real function rand (seed)
c-----------------------------------------------------------------------
c   basic uniform (0,1) random number generator function
c   rand  (resulting random number in the range (0,1), output)
c   seed  (seed number with a value in the exclusive range (0,1)
c          seed is replaced by a new value to be used
c          in a subsequent call, input/output)
c-----------------------------------------------------------------------
      real seed
      real d2p31m,d2p31
c                                  d2p31m=(2**31) - 1
c                                  d2p31 =(2**31)(or an adjusted value)
      data d2p31m /2.147483647e9/
      data d2p31  /2.147483648e9/
c-----------------------------------------------------------------------
c  generation of random number.
c-----------------------------------------------------------------------
      seed = seed*2.147483646e9+1.
      seed = mod(1.6807e4*seed,d2p31m)
      seed = max(seed,1.)
      rand = seed/d2p31
      seed = (seed-1.)/2.147483646e9
c-----------------------------------------------------------------------
c  end
c-----------------------------------------------------------------------
      return
      end
