      subroutine tstep
c-----------------------------------------------------------------------
c  dt for 3d isothermal mhd code
c-----------------------------------------------------------------------
      implicit none
c
      include 'mpif.h'
      include 'common.inc'
c
      integer i, j, k
      real dtp, vxmax, vymax, vzmax
      real rhohat(-1:nw+2),
     &     vxhat(-1:nw+2), vyhat(-1:nw+2), vzhat(-1:nw+2), 
     &     bxhat(-1:nw+2), byhat(-1:nw+2), bzhat(-1:nw+2)
      real bx(-1:nw+2), by(-1:nw+2), bz(-1:nw+2), cf(-1:nw+2)
c
      vxmax = 0.
      vymax = 0.
      vzmax = 0.
c-----------------------------------------------------------------------
c  along x
c-----------------------------------------------------------------------
      do 111 k=1,nzp
      do 111 j=1,ny
c-----------------------------------------------------------------------
c  assignment
c-----------------------------------------------------------------------
      do 112 i=-1,nx+2
         qw1(i) = q1(i,j,k)
         qw2(i) = q2(i,j,k)
         qw5(i) = q5(i,j,k)
         qw6(i) = q6(i,j,k)
         qw7(i) = q7(i,j,k)
 112  continue
c-----------------------------------------------------------------------
c  rho(i+1/2), vx(i+1/2), Bx(i+1/2), By(i+1/2), Bz(i+1/2)
c-----------------------------------------------------------------------
      do 113 i=-1,nx+1
         rhohat(i)= 0.5*(qw1(i)+qw1(i+1))
         vxhat(i) = 0.5*(qw2(i)/qw1(i)+qw2(i+1)/qw1(i+1))
         bxhat(i) = 0.5*(qw5(i)+qw5(i+1))
         byhat(i) = 0.5*(qw6(i)+qw6(i+1))
         bzhat(i) = 0.5*(qw7(i)+qw7(i+1))
 113  continue
c-----------------------------------------------------------------------
c  bx(i+1/2), by(i+1/2), bz(i+1/2), cf(i+1/2)
c-----------------------------------------------------------------------
      do 114 i=-1,nx+1
         bx(i) = bxhat(i) / sqrt(rhohat(i))
         by(i) = byhat(i) / sqrt(rhohat(i))
         bz(i) = bzhat(i) / sqrt(rhohat(i))
         cf(i) = 0.5 * (a**2+bx(i)**2+by(i)**2+bz(i)**2
     &     +sqrt(max(0.,
     &        (a**2+bx(i)**2+by(i)**2+bz(i)**2)**2-4.*a**2*bx(i)**2)))
         cf(i) = sqrt(cf(i))
 114  continue
c-----------------------------------------------------------------------
c  vxmax+cfmax
c-----------------------------------------------------------------------
      do 115 i=0,nx
         vxmax  = max(vxmax,abs(vxhat(i))+cf(i))
 115  continue
c-----------------------------------------------------------------------
c  along x
c-----------------------------------------------------------------------
 111  continue
c-----------------------------------------------------------------------
c  along y
c-----------------------------------------------------------------------
      do 121 k=1,nzp
      do 121 i=1,nx
c-----------------------------------------------------------------------
c  assignment
c-----------------------------------------------------------------------
      do 122 j=-1,ny+2
         qw1(j) = q1(i,j,k)
         qw3(j) = q3(i,j,k)
         qw5(j) = q5(i,j,k)
         qw6(j) = q6(i,j,k)
         qw7(j) = q7(i,j,k)
 122  continue
c-----------------------------------------------------------------------
c  rho(j+1/2), vy(j+1/2), Bx(j+1/2), By(j+1/2), Bz(j+1/2)
c-----------------------------------------------------------------------
      do 123 j=-1,ny+1
         rhohat(j)= 0.5*(qw1(j)+qw1(j+1))
         vyhat(j) = 0.5*(qw3(j)/qw1(j)+qw3(j+1)/qw1(j+1))
         bxhat(j) = 0.5*(qw5(j)+qw5(j+1))
         byhat(j) = 0.5*(qw6(j)+qw6(j+1))
         bzhat(j) = 0.5*(qw7(j)+qw7(j+1))
 123  continue
c-----------------------------------------------------------------------
c  bx(j+1/2), by(j+1/2), bz(j+1/2), cf(j+1/2)
c-----------------------------------------------------------------------
      do 124 j=-1,ny+1
         bx(j) = bxhat(j) / sqrt(rhohat(j))
         by(j) = byhat(j) / sqrt(rhohat(j))
         bz(j) = bzhat(j) / sqrt(rhohat(j))
         cf(j) = 0.5 * (a**2+bx(j)**2+by(j)**2+bz(j)**2
     &     +sqrt(max(0.,
     &        (a**2+bx(j)**2+by(j)**2+bz(j)**2)**2-4.*a**2*by(j)**2)))
         cf(j) = sqrt(cf(j))
 124  continue
c-----------------------------------------------------------------------
c  vymax+cfmax
c-----------------------------------------------------------------------
      do 125 j=0,ny
         vymax = max(vymax,abs(vyhat(j))+cf(j))
 125  continue
c-----------------------------------------------------------------------
c  along y
c-----------------------------------------------------------------------
 121  continue
c-----------------------------------------------------------------------
c  along z
c-----------------------------------------------------------------------
      do 131 j=1,ny
      do 131 i=1,nx
c-----------------------------------------------------------------------
c  assignment
c-----------------------------------------------------------------------
      do 132 k=0,nzp+1
         qw1(k) = q1(i,j,k)
         qw4(k) = q4(i,j,k)
         qw5(k) = q5(i,j,k)
         qw6(k) = q6(i,j,k)
         qw7(k) = q7(i,j,k)
 132  continue
c-----------------------------------------------------------------------
c  rho(k+1/2), vz(k+1/2), Bx(k+1/2), By(k+1/2), Bz(k+1/2)
c-----------------------------------------------------------------------
      do 133 k=0,nzp
         rhohat(k)= 0.5*(qw1(k)+qw1(k+1))
         vzhat(k) = 0.5*(qw4(k)/qw1(k)+qw4(k+1)/qw1(k+1))
         bxhat(k) = 0.5*(qw5(k)+qw5(k+1))
         byhat(k) = 0.5*(qw6(k)+qw6(k+1))
         bzhat(k) = 0.5*(qw7(k)+qw7(k+1))
 133  continue
c-----------------------------------------------------------------------
c  bx(k+1/2), by(k+1/2), bz(k+1/2), cf(k+1/2)
c-----------------------------------------------------------------------
      do 134 k=0,nzp
         bx(k) = bxhat(k) / sqrt(rhohat(k))
         by(k) = byhat(k) / sqrt(rhohat(k))
         bz(k) = bzhat(k) / sqrt(rhohat(k))
         cf(k) = 0.5 * (a**2+bx(k)**2+by(k)**2+bz(k)**2
     &     +sqrt(max(0.,
     &        (a**2+bx(k)**2+by(k)**2+bz(k)**2)**2-4.*a**2*bz(k)**2)))
         cf(k) = sqrt(cf(k))
 134  continue
c-----------------------------------------------------------------------
c  vzmax+cfmax
c-----------------------------------------------------------------------
      do 135 k=0,nzp
         vzmax = max(vzmax,abs(vzhat(k))+cf(k))
 135  continue
c-----------------------------------------------------------------------
c  along z
c-----------------------------------------------------------------------
 131  continue
c-----------------------------------------------------------------------
c  dt at each processor 
c-----------------------------------------------------------------------
      vxmax = cour/vxmax*dx
      vymax = cour/vymax*dy
      vzmax = cour/vzmax*dz
      dtp = min(vxmax,vymax,vzmax)
c
      call MPI_BARRIER (MPI_COMM_WORLD,err)
c-----------------------------------------------------------------------
c  dt
c-----------------------------------------------------------------------
      call MPI_REDUCE (dtp,dt,1,MPI_REAL,MPI_MIN,master,
     +                 MPI_COMM_WORLD,err)
      call MPI_BCAST (dt,1,MPI_REAL,master,MPI_COMM_WORLD,err)
c
      call MPI_BARRIER (MPI_COMM_WORLD,err)
c-----------------------------------------------------------------------
c  end
c-----------------------------------------------------------------------
      return
      end
