      subroutine bound1
c-----------------------------------------------------------------------
c  x and y boundary condition for 3d plane-parallel Parker instability  
c-----------------------------------------------------------------------
      implicit none
c
      include 'mpif.h'
      include 'common.inc'
c
      integer i, j, k
c-----------------------------------------------------------------------
c  x-boundary (Periodic)
c-----------------------------------------------------------------------
      do 111 k=1,nzp
      do 111 j=1,ny
         q1(  -1,j,k) =  q1(nx-1,j,k)
         q1(   0,j,k) =  q1(  nx,j,k)
         q1(nx+1,j,k) =  q1(   1,j,k)
         q1(nx+2,j,k) =  q1(   2,j,k)
c
         q2(  -1,j,k) =  q2(nx-1,j,k)
         q2(   0,j,k) =  q2(  nx,j,k)
         q2(nx+1,j,k) =  q2(   1,j,k)
         q2(nx+2,j,k) =  q2(   2,j,k)
c
         q3(  -1,j,k) =  q3(nx-1,j,k)
         q3(   0,j,k) =  q3(  nx,j,k)
         q3(nx+1,j,k) =  q3(   1,j,k)
         q3(nx+2,j,k) =  q3(   2,j,k)
c
         q4(  -1,j,k) =  q4(nx-1,j,k)
         q4(   0,j,k) =  q4(  nx,j,k)
         q4(nx+1,j,k) =  q4(   1,j,k)
         q4(nx+2,j,k) =  q4(   2,j,k)
c
         q5(  -1,j,k) =  q5(nx-1,j,k)
         q5(   0,j,k) =  q5(  nx,j,k)
         q5(nx+1,j,k) =  q5(   1,j,k)
         q5(nx+2,j,k) =  q5(   2,j,k)
c
         q6(  -1,j,k) =  q6(nx-1,j,k)
         q6(   0,j,k) =  q6(  nx,j,k)
         q6(nx+1,j,k) =  q6(   1,j,k)
         q6(nx+2,j,k) =  q6(   2,j,k)
c
         q7(  -1,j,k) =  q7(nx-1,j,k)
         q7(   0,j,k) =  q7(  nx,j,k)
         q7(nx+1,j,k) =  q7(   1,j,k)
         q7(nx+2,j,k) =  q7(   2,j,k)
 111  continue
c-----------------------------------------------------------------------
c  y-boundary (Reflecting)
c-----------------------------------------------------------------------
      do 121 k=1,nzp
      do 121 i=1,nx
         q1(i,  -1,k) =  q1(i,   2,k)
         q1(i,   0,k) =  q1(i,   1,k)
         q1(i,ny+1,k) =  q1(i,  ny,k)
         q1(i,ny+2,k) =  q1(i,ny-1,k)
c
         q2(i,  -1,k) =  q2(i,   2,k)
         q2(i,   0,k) =  q2(i,   1,k)
         q2(i,ny+1,k) =  q2(i,  ny,k)
         q2(i,ny+2,k) =  q2(i,ny-1,k)
c
         q3(i,  -1,k) = -q3(i,   2,k)
         q3(i,   0,k) = -q3(i,   1,k)
         q3(i,ny+1,k) = -q3(i,  ny,k)
         q3(i,ny+2,k) = -q3(i,ny-1,k)
c
         q4(i,  -1,k) =  q4(i,   2,k)
         q4(i,   0,k) =  q4(i,   1,k)
         q4(i,ny+1,k) =  q4(i,  ny,k)
         q4(i,ny+2,k) =  q4(i,ny-1,k)
c
         q5(i,  -1,k) =  q5(i,   2,k)
         q5(i,   0,k) =  q5(i,   1,k)
         q5(i,ny+1,k) =  q5(i,  ny,k)
         q5(i,ny+2,k) =  q5(i,ny-1,k)
c
         q6(i,  -1,k) = -q6(i,   2,k)
         q6(i,   0,k) = -q6(i,   1,k)
         q6(i,ny+1,k) = -q6(i,  ny,k)
         q6(i,ny+2,k) = -q6(i,ny-1,k)
c
         q7(i,  -1,k) =  q7(i,   2,k)
         q7(i,   0,k) =  q7(i,   1,k)
         q7(i,ny+1,k) =  q7(i,  ny,k)
         q7(i,ny+2,k) =  q7(i,ny-1,k)
 121  continue
c
      call MPI_BARRIER (MPI_COMM_WORLD,err)
c-----------------------------------------------------------------------
c  end
c-----------------------------------------------------------------------
      return
      end
