      subroutine divb
c-----------------------------------------------------------------------
c  correction to enforce divb=0 with 3d plane-parallel MHD KH instab
c      written by Dongsu Ryu (July 1994)
c  subroutine - ccfft
c               bound1
c               bound2
c               prot
c-----------------------------------------------------------------------
      implicit none
c
      include 'mpif.h'
      include 'common.inc'
c
      integer ix, ix1, ix2, iy, iy1, iy2, iz, iz1, iz2, iq
      real bx(nx2,ny2,0:nzp2+1), by(nx2,ny2,0:nzp2+1),
     +     bz(nx2,ny2,0:nzp2+1), db(nx2,ny2,0:nzp2+1)
      integer nsize, nsour, ndest
      real dbb1(nx2,ny2), dbb2(nx2,ny2)
      real cs(nx2/2,ny2/2,nzp2)
      real ct0(nx2/2,ny2/2,nzp2), ct1(nx2/2,ny2/2,nzp2),
     +     ct2(nx2/2,ny2/2,nzp2), ct3(nx2/2,ny2/2,nzp2)
      complex cu(nzp2*4,ny2/2,nzp2*4)
      complex cv00(nzp2*4,ny2/2,nzp2*4), cv01(nzp2*4,ny2/2,nzp2*4),
     +        cv02(nzp2*4,ny2/2,nzp2*4), cv03(nzp2*4,ny2/2,nzp2*4),
     +        cv04(nzp2*4,ny2/2,nzp2*4), cv05(nzp2*4,ny2/2,nzp2*4),
     +        cv06(nzp2*4,ny2/2,nzp2*4), cv07(nzp2*4,ny2/2,nzp2*4),
     +        cv08(nzp2*4,ny2/2,nzp2*4), cv09(nzp2*4,ny2/2,nzp2*4),
     +        cv10(nzp2*4,ny2/2,nzp2*4), cv11(nzp2*4,ny2/2,nzp2*4),
     +        cv12(nzp2*4,ny2/2,nzp2*4), cv13(nzp2*4,ny2/2,nzp2*4),
     +        cv14(nzp2*4,ny2/2,nzp2*4), cv15(nzp2*4,ny2/2,nzp2*4),
     +        cv16(nzp2*4,ny2/2,nzp2*4), cv17(nzp2*4,ny2/2,nzp2*4),
     +        cv18(nzp2*4,ny2/2,nzp2*4), cv19(nzp2*4,ny2/2,nzp2*4),
     +        cv20(nzp2*4,ny2/2,nzp2*4), cv21(nzp2*4,ny2/2,nzp2*4),
     +        cv22(nzp2*4,ny2/2,nzp2*4), cv23(nzp2*4,ny2/2,nzp2*4),
     +        cv24(nzp2*4,ny2/2,nzp2*4), cv25(nzp2*4,ny2/2,nzp2*4),
     +        cv26(nzp2*4,ny2/2,nzp2*4), cv27(nzp2*4,ny2/2,nzp2*4),
     +        cv28(nzp2*4,ny2/2,nzp2*4), cv29(nzp2*4,ny2/2,nzp2*4),
     +        cv30(nzp2*4,ny2/2,nzp2*4), cv31(nzp2*4,ny2/2,nzp2*4)
      real xl, yl, zl
      integer isign, isys
      real scale, tablex(nx2), tabley(ny2), tablez(nz2),
     +     workx(2*nx2), worky(2*ny2), workz(2*nz2)
      complex cw1(nx2/2,ny2/2,nzp2*4),
     +        cx1(0:nx2/2-1), cx2(0:nx2/2-1),
     +        cy1(0:ny2/2-1), cy2(0:ny2/2-1),
     +        cz1(0:nz2/2-1), cz2(0:nz2/2-1)
      integer itmpx, itmpy, itmpz
      real wtemp1, wtemp2, wtemp3, wtemp4
c-----------------------------------------------------------------------
      itmpx = nx2/2
      itmpy = ny2/2
      itmpz = nz2/2
c
      wtemp1 = 1./real(itmpx)
      wtemp2 = 1./real(itmpy)
      wtemp3 = 1./real(itmpz)
c-----------------------------------------------------------------------
      do 101 iz=0,nzp+1
      do 101 iy=1,ny
      do 101 ix=1,nx
c
         bx(ix,iy,iz) = q5(ix,iy,iz)
         by(ix,iy,iz) = q6(ix,iy,iz)
         bz(ix,iy,iz) = q7(ix,iy,iz)
c
         bx(ix,2*ny-iy+1,iz) =  q5(ix,iy,iz)
         by(ix,2*ny-iy+1,iz) = -q6(ix,iy,iz)
         bz(ix,2*ny-iy+1,iz) =  q7(ix,iy,iz)
c
 101  continue
c-----------------------------------------------------------------------
      do 102 iz=1,nzp2
      do 102 iy=1,ny2
      do 102 ix=1,nx2
c
         if (ix.eq.1) then
            ix1 = ix+1
            ix2 = nx2
         elseif (ix.eq.nx2) then
            ix1 = 1
            ix2 = ix-1
         else
            ix1 = ix+1
            ix2 = ix-1
         endif
c
         if (iy.eq.1) then
            iy1 = iy+1
            iy2 = ny2
         elseif (iy.eq.ny2) then
            iy1 = 1
            iy2 = iy-1
         else
            iy1 = iy+1
            iy2 = iy-1
         endif
c
         iz1 = iz+1
         iz2 = iz-1
c
         db(ix,iy,iz) = (bx(ix2,iy,iz)-bx(ix1,iy,iz)
     +                  +by(ix,iy2,iz)-by(ix,iy1,iz)
     +                  +bz(ix,iy,iz2)-bz(ix,iy,iz1))*0.5
c
 102  continue
c
      call MPI_BARRIER (MPI_COMM_WORLD,err)
c-----------------------------------------------------------------------
      do 103 iz=1,nzp2
      do 103 iy=1,ny2/2
      do 103 ix=1,nx2/2
         ct0(ix,iy,iz) = db(2*ix-1,2*iy-1,iz)
         ct1(ix,iy,iz) = db(2*ix  ,2*iy-1,iz)
         ct2(ix,iy,iz) = db(2*ix-1,2*iy  ,iz)
         ct3(ix,iy,iz) = db(2*ix  ,2*iy  ,iz)
 103  continue
c
      nsize = nx2*ny2*nzp2/4
c
      ndest = (pi/8)*8+mod(pi,2)*4+0
      call MPI_SEND (ct0,nsize,MPI_REAL,ndest,pi,MPI_COMM_WORLD,err)
      ndest = (pi/8)*8+mod(pi,2)*4+1
      call MPI_SEND (ct1,nsize,MPI_REAL,ndest,pi,MPI_COMM_WORLD,err)
      ndest = (pi/8)*8+mod(pi,2)*4+2
      call MPI_SEND (ct2,nsize,MPI_REAL,ndest,pi,MPI_COMM_WORLD,err)
      ndest = (pi/8)*8+mod(pi,2)*4+3
      call MPI_SEND (ct3,nsize,MPI_REAL,ndest,pi,MPI_COMM_WORLD,err)
c
      call MPI_BARRIER (MPI_COMM_WORLD,err)
c
      do 104 iq=1,4
c
         call MPI_RECV (cs,nsize,MPI_REAL,MPI_ANY_SOURCE,MPI_ANY_TAG,
     +                  MPI_COMM_WORLD,status,err)
         nsour = status(MPI_SOURCE)
         nsour = mod(nsour,8)/2
c
         do 105 iz=1,nzp2
         do 105 iy=1,ny2/2
         do 105 ix=1,nx2/2
            cw1(ix,iy,iz+nzp2*nsour) = cs(ix,iy,iz)
 105     continue
c
 104  continue
c
      call MPI_BARRIER (MPI_COMM_WORLD,err)
c-----------------------------------------------------------------------
      isign = 0
      scale = 1.
      isys = 0
c
      do 111 ix=1,nx2/2
         cx1(ix-1) = cw1(ix,1,1)
 111  continue
      call ccfft (isign,itmpx,scale,cx1,cx2,tablex,workx,isys)
c
      do 112 iy=1,ny2/2
         cy1(iy-1) = cw1(1,iy,1)
 112  continue
      call ccfft (isign,itmpy,scale,cy1,cy2,tabley,worky,isys)
c
      do 113 iz=1,nz2/2
         cz1(iz-1) = cw1(iz,1,1)
 113  continue
      call ccfft (isign,itmpz,scale,cz1,cz2,tablez,workz,isys)
c-----------------------------------------------------------------------
      isign = 1
c
      do 121 iz=1,nzp2*4
      do 121 iy=1,ny2/2
         do 122 ix=1,nx2/2
            cx1(ix-1) = cw1(ix,iy,iz)
 122     continue
         call ccfft (isign,itmpx,scale,cx1,cx2,tablex,workx,isys)
         do 123 ix=1,nx2/2
            cw1(ix,iy,iz) = cx2(ix-1)
 123     continue
 121  continue
c
      do 124 iz=1,nzp2*4
      do 124 ix=1,nx2/2
         do 125 iy=1,ny2/2
            cy1(iy-1) = cw1(ix,iy,iz)
 125     continue
         call ccfft (isign,itmpy,scale,cy1,cy2,tabley,worky,isys)
         do 126 iy=1,ny2/2
            cw1(ix,iy,iz) = cy2(iy-1)
 126     continue
 124  continue
c-----------------------------------------------------------------------
      do 131 iz=1,nzp2*4
      do 131 iy=1,ny2/2
      do 131 ix=1,nzp2*4
         cv00(ix,iy,iz) = cw1(ix+ 0*nzp2*4,iy,iz)
         cv01(ix,iy,iz) = cw1(ix+ 1*nzp2*4,iy,iz)
         cv02(ix,iy,iz) = cw1(ix+ 2*nzp2*4,iy,iz)
         cv03(ix,iy,iz) = cw1(ix+ 3*nzp2*4,iy,iz)
         cv04(ix,iy,iz) = cw1(ix+ 4*nzp2*4,iy,iz)
         cv05(ix,iy,iz) = cw1(ix+ 5*nzp2*4,iy,iz)
         cv06(ix,iy,iz) = cw1(ix+ 6*nzp2*4,iy,iz)
         cv07(ix,iy,iz) = cw1(ix+ 7*nzp2*4,iy,iz)
         cv08(ix,iy,iz) = cw1(ix+ 8*nzp2*4,iy,iz)
         cv09(ix,iy,iz) = cw1(ix+ 9*nzp2*4,iy,iz)
         cv10(ix,iy,iz) = cw1(ix+10*nzp2*4,iy,iz)
         cv11(ix,iy,iz) = cw1(ix+11*nzp2*4,iy,iz)
         cv12(ix,iy,iz) = cw1(ix+12*nzp2*4,iy,iz)
         cv13(ix,iy,iz) = cw1(ix+13*nzp2*4,iy,iz)
         cv14(ix,iy,iz) = cw1(ix+14*nzp2*4,iy,iz)
         cv15(ix,iy,iz) = cw1(ix+15*nzp2*4,iy,iz)
         cv16(ix,iy,iz) = cw1(ix+16*nzp2*4,iy,iz)
         cv17(ix,iy,iz) = cw1(ix+17*nzp2*4,iy,iz)
         cv18(ix,iy,iz) = cw1(ix+18*nzp2*4,iy,iz)
         cv19(ix,iy,iz) = cw1(ix+19*nzp2*4,iy,iz)
         cv20(ix,iy,iz) = cw1(ix+20*nzp2*4,iy,iz)
         cv21(ix,iy,iz) = cw1(ix+21*nzp2*4,iy,iz)
         cv22(ix,iy,iz) = cw1(ix+22*nzp2*4,iy,iz)
         cv23(ix,iy,iz) = cw1(ix+23*nzp2*4,iy,iz)
         cv24(ix,iy,iz) = cw1(ix+24*nzp2*4,iy,iz)
         cv25(ix,iy,iz) = cw1(ix+25*nzp2*4,iy,iz)
         cv26(ix,iy,iz) = cw1(ix+26*nzp2*4,iy,iz)
         cv27(ix,iy,iz) = cw1(ix+27*nzp2*4,iy,iz)
         cv28(ix,iy,iz) = cw1(ix+28*nzp2*4,iy,iz)
         cv29(ix,iy,iz) = cw1(ix+29*nzp2*4,iy,iz)
         cv30(ix,iy,iz) = cw1(ix+30*nzp2*4,iy,iz)
         cv31(ix,iy,iz) = cw1(ix+31*nzp2*4,iy,iz)
 131  continue
c
      nsize = ny2*nzp2*nzp2*8
c
      ndest = mod(pi,8)+8* 0
      call MPI_SEND (cv00,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8* 1
      call MPI_SEND (cv01,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8* 2
      call MPI_SEND (cv02,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8* 3
      call MPI_SEND (cv03,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8* 4
      call MPI_SEND (cv04,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8* 5
      call MPI_SEND (cv05,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8* 6
      call MPI_SEND (cv06,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8* 7
      call MPI_SEND (cv07,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8* 8
      call MPI_SEND (cv08,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8* 9
      call MPI_SEND (cv09,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*10
      call MPI_SEND (cv10,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*11
      call MPI_SEND (cv11,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*12
      call MPI_SEND (cv12,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*13
      call MPI_SEND (cv13,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*14
      call MPI_SEND (cv14,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*15
      call MPI_SEND (cv15,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*16
      call MPI_SEND (cv16,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*17
      call MPI_SEND (cv17,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*18
      call MPI_SEND (cv18,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*19
      call MPI_SEND (cv19,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*20
      call MPI_SEND (cv20,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*21
      call MPI_SEND (cv21,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*22
      call MPI_SEND (cv22,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*23
      call MPI_SEND (cv23,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*24
      call MPI_SEND (cv24,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*25
      call MPI_SEND (cv25,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*26
      call MPI_SEND (cv26,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*27
      call MPI_SEND (cv27,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*28
      call MPI_SEND (cv28,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*29
      call MPI_SEND (cv29,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*30
      call MPI_SEND (cv30,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*31
      call MPI_SEND (cv31,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
c
      call MPI_BARRIER (MPI_COMM_WORLD,err)
c
      do 132 iq=1,32
c
         call MPI_RECV (cu,nsize,MPI_COMPLEX,MPI_ANY_SOURCE,MPI_ANY_TAG,
     +                  MPI_COMM_WORLD,status,err)
         nsour = status(MPI_SOURCE)
         nsour = nsour/8
c
         do 133 ix=1,nzp2*4
         do 133 iy=1,ny2/2
         do 133 iz=1,nzp2*4
            cw1(iz+nsour*nzp2*4,iy,ix) = cu(ix,iy,iz)
 133     continue
c
 132  continue
c-----------------------------------------------------------------------
      do 127 ix=1,nzp2*4
      do 127 iy=1,ny2/2
         do 128 iz=1,nz2/2
            cz1(iz-1) = cw1(iz,iy,ix)
 128     continue
         call ccfft (isign,itmpz,scale,cz1,cz2,tablez,workz,isys)
         do 129 iz=1,nz2/2
            cw1(iz,iy,ix) = cz2(iz-1)
 129     continue
 127  continue
c-----------------------------------------------------------------------
      do 141 ix=1,nzp2*4
      do 141 iy=1,ny2/2
      do 141 iz=1,nz2/2
         xl = 2.*3.14159265358979323846*real(ix-1+(pi/8)*nzp2*4)*wtemp1
         yl = 2.*3.14159265358979323846*real(iy-1)*wtemp2
         zl = 2.*3.14159265358979323846*real(iz-1)*wtemp3
         if (((ix-1+(pi/8)*nzp2*4).eq.0).and.((iy-1).eq.0)
     +                                  .and.((iz-1).eq.0)) then
            cw1(iz,iy,ix) = (0.,0.)
         else
            cw1(iz,iy,ix) = cw1(iz,iy,ix)
     +                      /(2.*(cos(xl)+cos(yl)+cos(zl)-3.))
         endif
 141  continue
c-----------------------------------------------------------------------
      isign = -1
c
      do 151 ix=1,nzp2*4
      do 151 iy=1,ny2/2
         do 152 iz=1,nz2/2
            cz1(iz-1) = cw1(iz,iy,ix)
 152     continue
         call ccfft (isign,itmpz,scale,cz1,cz2,tablez,workz,isys)
         do 153 iz=1,nz2/2
            cw1(iz,iy,ix) = cz2(iz-1)
 153     continue
 151  continue
c-----------------------------------------------------------------------
      do 161 ix=1,nzp2*4
      do 161 iy=1,ny2/2
      do 161 iz=1,nzp2*4
         cv00(iz,iy,ix) = cw1(iz+ 0*nzp2*4,iy,ix)
         cv01(iz,iy,ix) = cw1(iz+ 1*nzp2*4,iy,ix)
         cv02(iz,iy,ix) = cw1(iz+ 2*nzp2*4,iy,ix)
         cv03(iz,iy,ix) = cw1(iz+ 3*nzp2*4,iy,ix)
         cv04(iz,iy,ix) = cw1(iz+ 4*nzp2*4,iy,ix)
         cv05(iz,iy,ix) = cw1(iz+ 5*nzp2*4,iy,ix)
         cv06(iz,iy,ix) = cw1(iz+ 6*nzp2*4,iy,ix)
         cv07(iz,iy,ix) = cw1(iz+ 7*nzp2*4,iy,ix)
         cv08(iz,iy,ix) = cw1(iz+ 8*nzp2*4,iy,ix)
         cv09(iz,iy,ix) = cw1(iz+ 9*nzp2*4,iy,ix)
         cv10(iz,iy,ix) = cw1(iz+10*nzp2*4,iy,ix)
         cv11(iz,iy,ix) = cw1(iz+11*nzp2*4,iy,ix)
         cv12(iz,iy,ix) = cw1(iz+12*nzp2*4,iy,ix)
         cv13(iz,iy,ix) = cw1(iz+13*nzp2*4,iy,ix)
         cv14(iz,iy,ix) = cw1(iz+14*nzp2*4,iy,ix)
         cv15(iz,iy,ix) = cw1(iz+15*nzp2*4,iy,ix)
         cv16(iz,iy,ix) = cw1(iz+16*nzp2*4,iy,ix)
         cv17(iz,iy,ix) = cw1(iz+17*nzp2*4,iy,ix)
         cv18(iz,iy,ix) = cw1(iz+18*nzp2*4,iy,ix)
         cv19(iz,iy,ix) = cw1(iz+19*nzp2*4,iy,ix)
         cv20(iz,iy,ix) = cw1(iz+20*nzp2*4,iy,ix)
         cv21(iz,iy,ix) = cw1(iz+21*nzp2*4,iy,ix)
         cv22(iz,iy,ix) = cw1(iz+22*nzp2*4,iy,ix)
         cv23(iz,iy,ix) = cw1(iz+23*nzp2*4,iy,ix)
         cv24(iz,iy,ix) = cw1(iz+24*nzp2*4,iy,ix)
         cv25(iz,iy,ix) = cw1(iz+25*nzp2*4,iy,ix)
         cv26(iz,iy,ix) = cw1(iz+26*nzp2*4,iy,ix)
         cv27(iz,iy,ix) = cw1(iz+27*nzp2*4,iy,ix)
         cv28(iz,iy,ix) = cw1(iz+28*nzp2*4,iy,ix)
         cv29(iz,iy,ix) = cw1(iz+29*nzp2*4,iy,ix)
         cv30(iz,iy,ix) = cw1(iz+30*nzp2*4,iy,ix)
         cv31(iz,iy,ix) = cw1(iz+31*nzp2*4,iy,ix)
 161  continue
c
      nsize = ny2*nzp2*nzp2*8
c
      ndest = mod(pi,8)+8* 0
      call MPI_SEND (cv00,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8* 1
      call MPI_SEND (cv01,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8* 2
      call MPI_SEND (cv02,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8* 3
      call MPI_SEND (cv03,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8* 4
      call MPI_SEND (cv04,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8* 5
      call MPI_SEND (cv05,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8* 6
      call MPI_SEND (cv06,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8* 7
      call MPI_SEND (cv07,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8* 8
      call MPI_SEND (cv08,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8* 9
      call MPI_SEND (cv09,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*10
      call MPI_SEND (cv10,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*11
      call MPI_SEND (cv11,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*12
      call MPI_SEND (cv12,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*13
      call MPI_SEND (cv13,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*14
      call MPI_SEND (cv14,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*15
      call MPI_SEND (cv15,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*16
      call MPI_SEND (cv16,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*17
      call MPI_SEND (cv17,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*18
      call MPI_SEND (cv18,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*19
      call MPI_SEND (cv19,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*20
      call MPI_SEND (cv20,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*21
      call MPI_SEND (cv21,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*22
      call MPI_SEND (cv22,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*23
      call MPI_SEND (cv23,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*24
      call MPI_SEND (cv24,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*25
      call MPI_SEND (cv25,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*26
      call MPI_SEND (cv26,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*27
      call MPI_SEND (cv27,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*28
      call MPI_SEND (cv28,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*29
      call MPI_SEND (cv29,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*30
      call MPI_SEND (cv30,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
      ndest = mod(pi,8)+8*31
      call MPI_SEND (cv31,nsize,MPI_COMPLEX,ndest,pi,MPI_COMM_WORLD,err)
c
      call MPI_BARRIER (MPI_COMM_WORLD,err)
c
      do 162 iq=1,32
c
         call MPI_RECV (cu,nsize,MPI_COMPLEX,MPI_ANY_SOURCE,MPI_ANY_TAG,
     +                  MPI_COMM_WORLD,status,err)
         nsour = status(MPI_SOURCE)
         nsour = nsour/8
c
         do 163 iz=1,nzp2*4
         do 163 iy=1,ny2/2
         do 163 ix=1,nzp2*4
            cw1(ix+nsour*nzp2*4,iy,iz) = cu(iz,iy,ix)
 163     continue
c
 162  continue
c-----------------------------------------------------------------------
      do 154 iz=1,nzp2*4
      do 154 ix=1,nx2/2
         do 155 iy=1,ny2/2
            cy1(iy-1) = cw1(ix,iy,iz)
 155     continue
         call ccfft (isign,itmpy,scale,cy1,cy2,tabley,worky,isys)
         do 156 iy=1,ny2/2
            cw1(ix,iy,iz) = cy2(iy-1)
 156     continue
 154  continue
c
      do 157 iz=1,nzp2*4
      do 157 iy=1,ny2/2
         do 158 ix=1,nx2/2
            cx1(ix-1) = cw1(ix,iy,iz)
 158     continue
         call ccfft (isign,itmpx,scale,cx1,cx2,tablex,workx,isys)
         do 159 ix=1,nx2/2
            cw1(ix,iy,iz) = cx2(ix-1)
 159     continue
 157  continue
c-----------------------------------------------------------------------
      wtemp4 = 1./(real(nx2*ny2*nz2/8))
c
      do 171 iz=1,nzp2*4
      do 171 iy=1,ny2/2
      do 171 ix=1,nx2/2
         cw1(ix,iy,iz) = 4.*cw1(ix,iy,iz)*wtemp4
 171  continue
c
      call MPI_BARRIER (MPI_COMM_WORLD,err)
c-----------------------------------------------------------------------
      do 181 iz=1,nzp2
      do 181 iy=1,ny2/2
      do 181 ix=1,nx2/2
         ct0(ix,iy,iz) = cw1(ix,iy,iz+nzp2*0)
         ct1(ix,iy,iz) = cw1(ix,iy,iz+nzp2*1)
         ct2(ix,iy,iz) = cw1(ix,iy,iz+nzp2*2)
         ct3(ix,iy,iz) = cw1(ix,iy,iz+nzp2*3)
 181  continue
c
      nsize = nx2*ny2*nzp2/4
c
      ndest = (pi/8)*8+mod(pi,8)/4+0
      call MPI_SEND (ct0,nsize,MPI_REAL,ndest,pi,MPI_COMM_WORLD,err)
      ndest = (pi/8)*8+mod(pi,8)/4+2
      call MPI_SEND (ct1,nsize,MPI_REAL,ndest,pi,MPI_COMM_WORLD,err)
      ndest = (pi/8)*8+mod(pi,8)/4+4
      call MPI_SEND (ct2,nsize,MPI_REAL,ndest,pi,MPI_COMM_WORLD,err)
      ndest = (pi/8)*8+mod(pi,8)/4+6
      call MPI_SEND (ct3,nsize,MPI_REAL,ndest,pi,MPI_COMM_WORLD,err)
c
      call MPI_BARRIER (MPI_COMM_WORLD,err)
c
      do 182 iq=1,4
c
         call MPI_RECV (cs,nsize,MPI_REAL,MPI_ANY_SOURCE,MPI_ANY_TAG,
     +                  MPI_COMM_WORLD,status,err)
         nsour = status(MPI_SOURCE)
         nsour = mod(nsour,4)
c
         if (nsour.eq.0) then
            do 183 iz=1,nzp2
            do 183 iy=1,ny2/2
            do 183 ix=1,nx2/2
               db(2*ix-1,2*iy-1,iz) = cs(ix,iy,iz)
 183        continue
         elseif (nsour.eq.1) then
            do 184 iz=1,nzp2
            do 184 iy=1,ny2/2
            do 184 ix=1,nx2/2
               db(2*ix  ,2*iy-1,iz) = cs(ix,iy,iz)
 184        continue
         elseif (nsour.eq.2) then
            do 185 iz=1,nzp2
            do 185 iy=1,ny2/2
            do 185 ix=1,nx2/2
               db(2*ix-1,2*iy  ,iz) = cs(ix,iy,iz)
 185        continue
         elseif (nsour.eq.3) then
            do 186 iz=1,nzp2
            do 186 iy=1,ny2/2
            do 186 ix=1,nx2/2
               db(2*ix  ,2*iy  ,iz) = cs(ix,iy,iz)
 186        continue
         endif
c
 182  continue
c
      call MPI_BARRIER (MPI_COMM_WORLD,err)
c-----------------------------------------------------------------------
      do 191 iy=1,ny2
      do 191 ix=1,nx2
c
         dbb1(ix,iy) = db(ix,iy,nzp2)
c
 191  continue
c
      if (pi.eq.(np-1)) then
         ndest = 0
      else
         ndest = pi+1
      endif
c
      nsize = nx2*ny2
c
      call MPI_SEND (dbb1,nsize,MPI_REAL,ndest,pi,MPI_COMM_WORLD,err)
c
      call MPI_BARRIER (MPI_COMM_WORLD,err)
c
      call MPI_RECV (dbb2,nsize,MPI_REAL,MPI_ANY_SOURCE,MPI_ANY_TAG,
     +               MPI_COMM_WORLD,status,err)
c
      do 192 iy=1,ny2
      do 192 ix=1,nx2
c
         db(ix,iy,0) = dbb2(ix,iy)
c
 192  continue
c
      call MPI_BARRIER (MPI_COMM_WORLD,err)
c
      do 193 iy=1,ny2
      do 193 ix=1,nx2
c
         dbb1(ix,iy) = db(ix,iy,1)
c
 193  continue
c
      if (pi.eq.0) then
         ndest = np-1
      else
         ndest = pi-1
      endif
c
      call MPI_SEND (dbb1,nsize,MPI_REAL,ndest,pi,MPI_COMM_WORLD,err)
c
      call MPI_BARRIER (MPI_COMM_WORLD,err)
c
      call MPI_RECV (dbb2,nsize,MPI_REAL,MPI_ANY_SOURCE,MPI_ANY_TAG,
     +               MPI_COMM_WORLD,status,err)
c
      do 194 iy=1,ny2
      do 194 ix=1,nx2
c
         db(ix,iy,nzp2+1) = dbb2(ix,iy)
c
 194  continue
c
      call MPI_BARRIER (MPI_COMM_WORLD,err)
c-----------------------------------------------------------------------
      do 195 iz=1,nzp2
      do 195 iy=1,ny2
      do 195 ix=1,nx2
c
         if (ix.eq.1) then
            ix1 = ix+1
            ix2 = nx2
         elseif (ix.eq.nx2) then
            ix1 = 1
            ix2 = ix-1
         else
            ix1 = ix+1
            ix2 = ix-1
         endif
c
         if (iy.eq.1) then
            iy1 = iy+1
            iy2 = ny2
         elseif (iy.eq.ny2) then
            iy1 = 1
            iy2 = iy-1
         else
            iy1 = iy+1
            iy2 = iy-1
         endif
c
         iz1 = iz+1
         iz2 = iz-1
c
         bx(ix,iy,iz) = bx(ix,iy,iz)+(db(ix1,iy,iz)-db(ix2,iy,iz))*0.5
         by(ix,iy,iz) = by(ix,iy,iz)+(db(ix,iy1,iz)-db(ix,iy2,iz))*0.5
         bz(ix,iy,iz) = bz(ix,iy,iz)+(db(ix,iy,iz1)-db(ix,iy,iz2))*0.5
c
 195  continue
c-----------------------------------------------------------------------
      do 196 iz=1,nzp
      do 196 iy=1,ny
      do 196 ix=1,nx
c
         q5(ix,iy,iz) = bx(ix,iy,iz)
         q6(ix,iy,iz) = by(ix,iy,iz)
         q7(ix,iy,iz) = bz(ix,iy,iz)
c
 196  continue
c
      call MPI_BARRIER (MPI_COMM_WORLD,err)
c
c     call prot
      call bound1
      call bound2
c-----------------------------------------------------------------------
      return
      end
