      subroutine mhdtvd
c-----------------------------------------------------------------------
c  mhd tvd code based on Harten (1983) and Brio and Wu (1988)
c  written by Dongsu Ryu (October, 1991)
c  isothermal mhd code was written by Jongsoo Kim (May 1997)
c-----------------------------------------------------------------------
      implicit none
c
      include 'mpif.h'
      include 'common.inc'
c
      integer i
      real eps1, eps2, eps3, dtdl
      real f1(-1:nw+2), f2(-1:nw+2), f3(-1:nw+2), f4(-1:nw+2),
     &       f5(-1:nw+2), f6(-1:nw+2)
      real rhohat(-1:nw+2), 
     &       vxhat(-1:nw+2), vyhat(-1:nw+2), vzhat(-1:nw+2),
     &       bxhat(-1:nw+2), byhat(-1:nw+2), bzhat(-1:nw+2)
      real bx(-1:nw+2), by(-1:nw+2), bz(-1:nw+2)
      real cf(-1:nw+2), ca(-1:nw+2), cs(-1:nw+2)
      real alpf(-1:nw+2), alps(-1:nw+2)
      real bety(-1:nw+2), betz(-1:nw+2)
      real the1(-1:nw+2), the2(-1:nw+2)
      real a1(-1:nw+2), a2(-1:nw+2), a3(-1:nw+2), a4(-1:nw+2), 
     &       a5(-1:nw+2), a6(-1:nw+2)
      real signbx(-1:nw+2), signbt
      real r1_1(-1:nw+2), r1_2(-1:nw+2), r1_3(-1:nw+2), r1_4(-1:nw+2),
     &       r1_5(-1:nw+2), r1_6(-1:nw+2),
     &       r2_1(-1:nw+2), r2_2(-1:nw+2), r2_3(-1:nw+2), r2_4(-1:nw+2),
     &       r2_5(-1:nw+2), r2_6(-1:nw+2),
     &       r3_1(-1:nw+2), r3_2(-1:nw+2), r3_3(-1:nw+2), r3_4(-1:nw+2),
     &       r3_5(-1:nw+2), r3_6(-1:nw+2),
     &       r4_1(-1:nw+2), r4_2(-1:nw+2), r4_3(-1:nw+2), r4_4(-1:nw+2),
     &       r4_5(-1:nw+2), r4_6(-1:nw+2),
     &       r5_1(-1:nw+2), r5_2(-1:nw+2), r5_3(-1:nw+2), r5_4(-1:nw+2),
     &       r5_5(-1:nw+2), r5_6(-1:nw+2),
     &       r6_1(-1:nw+2), r6_2(-1:nw+2), r6_3(-1:nw+2), r6_4(-1:nw+2),
     &       r6_5(-1:nw+2), r6_6(-1:nw+2)
      real l1_1(-1:nw+2), l1_2(-1:nw+2), l1_3(-1:nw+2), l1_4(-1:nw+2),
     &       l1_5(-1:nw+2), l1_6(-1:nw+2),
     &       l2_1(-1:nw+2), l2_2(-1:nw+2), l2_3(-1:nw+2), l2_4(-1:nw+2),
     &       l2_5(-1:nw+2), l2_6(-1:nw+2),
     &       l3_1(-1:nw+2), l3_2(-1:nw+2), l3_3(-1:nw+2), l3_4(-1:nw+2),
     &       l3_5(-1:nw+2), l3_6(-1:nw+2),
     &       l4_1(-1:nw+2), l4_2(-1:nw+2), l4_3(-1:nw+2), l4_4(-1:nw+2),
     &       l4_5(-1:nw+2), l4_6(-1:nw+2),
     &       l5_1(-1:nw+2), l5_2(-1:nw+2), l5_3(-1:nw+2), l5_4(-1:nw+2),
     &       l5_5(-1:nw+2), l5_6(-1:nw+2),
     &       l6_1(-1:nw+2), l6_2(-1:nw+2), l6_3(-1:nw+2), l6_4(-1:nw+2),
     &       l6_5(-1:nw+2), l6_6(-1:nw+2)
      real alp1(-1:nw+2), alp2(-1:nw+2), alp3(-1:nw+2), alp4(-1:nw+2),
     &       alp5(-1:nw+2), alp6(-1:nw+2)
      real gt1(-1:nw+2), gt2(-1:nw+2), gt3(-1:nw+2), gt4(-1:nw+2),
     &       gt5(-1:nw+2), gt6(-1:nw+2)
      real g1(-1:nw+2), g2(-1:nw+2), g3(-1:nw+2), g4(-1:nw+2),
     &       g5(-1:nw+2), g6(-1:nw+2)
      real gam1(-1:nw+2), gam2(-1:nw+2), gam3(-1:nw+2), gam4(-1:nw+2),
     &       gam5(-1:nw+2), gam6(-1:nw+2)
      real bet1(-1:nw+2), bet2(-1:nw+2), bet3(-1:nw+2), bet4(-1:nw+2),
     &       bet5(-1:nw+2), bet6(-1:nw+2)
      real fbar1(-1:nw+2), fbar2(-1:nw+2),
     &       fbar3(-1:nw+2), fbar4(-1:nw+2),
     &       fbar5(-1:nw+2), fbar6(-1:nw+2)
c
      dtdl = dt/dl
      eps1 = 0.10
      eps2 = 0.07
      eps3 = 0.01
c-----------------------------------------------------------------------
c  F(i)
c-----------------------------------------------------------------------
      do 101 i=-1,nd+2
         f1(i) = qw2(i)
         f2(i) = a**2*qw1(i)+qw2(i)**2/qw1(i) 
     &          +0.5*(qw6(i)**2+qw7(i)**2-qw5(i)**2)
         f3(i) = qw2(i)*qw3(i)/qw1(i) - qw5(i)*qw6(i)
         f4(i) = qw2(i)*qw4(i)/qw1(i) - qw5(i)*qw7(i)
         f5(i) = qw2(i)*qw6(i)/qw1(i) - qw3(i)*qw5(i)/qw1(i) 
         f6(i) = qw2(i)*qw7(i)/qw1(i) - qw4(i)*qw5(i)/qw1(i) 
 101  continue
c-----------------------------------------------------------------------
c  rho(i+1/2), vx(i+1/2), vy(i+1/2), vz(i+1/2), 
c              Bx(i+1/2), By(i+1/2), Bz(i+1/2)
c-----------------------------------------------------------------------
      do 102 i=-1,nd+1
         rhohat(i)= 0.5*(qw1(i)+qw1(i+1))
         vxhat(i) = 0.5*(qw2(i)/qw1(i)+qw2(i+1)/qw1(i+1))
         vyhat(i) = 0.5*(qw3(i)/qw1(i)+qw3(i+1)/qw1(i+1))
         vzhat(i) = 0.5*(qw4(i)/qw1(i)+qw4(i+1)/qw1(i+1))
         bxhat(i) = 0.5*(qw5(i)+qw5(i+1)) 
         byhat(i) = 0.5*(qw6(i)+qw6(i+1)) 
         bzhat(i) = 0.5*(qw7(i)+qw7(i+1)) 
 102  continue
c-----------------------------------------------------------------------
c  bx(i+1/2), by(i+1/2), bz(i+1/2), cf(i+1/2), ca(i+1/2), cs(i+1/2)
c-----------------------------------------------------------------------
      do 103 i=-1,nd+1
         bx(i) = bxhat(i) / sqrt(rhohat(i))
         by(i) = byhat(i) / sqrt(rhohat(i))
         bz(i) = bzhat(i) / sqrt(rhohat(i))
         cf(i) = 0.5 * (a**2+bx(i)**2+by(i)**2+bz(i)**2
     &    +sqrt(max(0.,
     &       (a**2+bx(i)**2+by(i)**2+bz(i)**2)**2-4.*a**2*bx(i)**2)))
         cf(i) = sqrt(max(0.,cf(i)))
         ca(i) = abs(bx(i))
         cs(i) = 0.5 * (a**2+bx(i)**2+by(i)**2+bz(i)**2
     &    -sqrt(max(0.,
     &       (a**2+bx(i)**2+by(i)**2+bz(i)**2)**2-4.*a**2*bx(i)**2)))
         cs(i) = sqrt(max(0.,cs(i)))
 103  continue
c-----------------------------------------------------------------------
c  alpf(i+1/2), alps(i+1/2), bety(i+1/2), betz(i+1/2)
c-----------------------------------------------------------------------
      do 104 i=-1,nd+1
         if ((cf(i)**2-cs(i)**2).ge.1.e-30) then
            alpf(i) = sqrt(max(0.,cf(i)**2-bx(i)**2))
     &               /sqrt(cf(i)**2-cs(i)**2)
            alps(i) = sqrt(max(0.,cf(i)**2-a**2))
     &               /sqrt(cf(i)**2-cs(i)**2)
         else
            alpf(i) = 1.
            alps(i) = 1.
         endif

         if ((by(i)**2+bz(i)**2).ge.1.e-30) then
            bety(i) = by(i)/sqrt(by(i)**2+bz(i)**2)
            betz(i) = bz(i)/sqrt(by(i)**2+bz(i)**2)
         else
            bety(i) = 1./sqrt(2.)
            betz(i) = 1./sqrt(2.)
c           bety(i) = 0.
c           betz(i) = 0.
         endif
 104  continue
c-----------------------------------------------------------------------
c  ak(i+1/2)
c-----------------------------------------------------------------------
      do 105 i=-1,nd+1
         a1(i) = vxhat(i)-cf(i)
         a2(i) = vxhat(i)-ca(i)
         a3(i) = vxhat(i)-cs(i)
         a4(i) = vxhat(i)+cs(i)
         a5(i) = vxhat(i)+ca(i)
         a6(i) = vxhat(i)+cf(i)
 105  continue
c-----------------------------------------------------------------------
c  R1k(i+1/2), R2k(i+1/2), R3k(i+1/2), R4k(i+1/2), R5k(i+1/2), R6k(i+1/2)
c-----------------------------------------------------------------------
      do 106 i=-1,nd+1
         signbx(i) = sign(1.,bx(i))
 106  continue
c
      do 107 i=-1,nd+1
         r1_1(i) =  alpf(i)
         r1_2(i) =  alpf(i)*(vxhat(i)-cf(i))
         r1_3(i) =  alpf(i)*vyhat(i)+alps(i)*bety(i)*bx(i)
         r1_4(i) =  alpf(i)*vzhat(i)+alps(i)*betz(i)*bx(i)
         r1_5(i) =  alps(i)*bety(i)*cf(i)/sqrt(rhohat(i))
         r1_6(i) =  alps(i)*betz(i)*cf(i)/sqrt(rhohat(i))
c
         r2_1(i) =  0.
         r2_2(i) =  0.
         r2_3(i) =  betz(i)*signbx(i)
         r2_4(i) = -bety(i)*signbx(i)
         r2_5(i) =  betz(i)/sqrt(rhohat(i)) 
         r2_6(i) = -bety(i)/sqrt(rhohat(i))
c
         r3_1(i) =  alps(i)
         r3_2(i) =  alps(i)*(vxhat(i)-cs(i))
         r3_3(i) =  alps(i)*vyhat(i)-alpf(i)*bety(i)*a*signbx(i)
         r3_4(i) =  alps(i)*vzhat(i)-alpf(i)*betz(i)*a*signbx(i)
         r3_5(i) = -alpf(i)*bety(i)*a**2/cf(i)/sqrt(rhohat(i))
         r3_6(i) = -alpf(i)*betz(i)*a**2/cf(i)/sqrt(rhohat(i))
c
         r4_1(i) =  alps(i)
         r4_2(i) =  alps(i)*(vxhat(i)+cs(i))
         r4_3(i) =  alps(i)*vyhat(i)+alpf(i)*bety(i)*a*signbx(i)
         r4_4(i) =  alps(i)*vzhat(i)+alpf(i)*betz(i)*a*signbx(i)
         r4_5(i) = -alpf(i)*bety(i)*a**2/cf(i)/sqrt(rhohat(i))
         r4_6(i) = -alpf(i)*betz(i)*a**2/cf(i)/sqrt(rhohat(i))
c
         r5_1(i) =  0.0
         r5_2(i) =  0.0
         r5_3(i) = -betz(i)*signbx(i)
         r5_4(i) =  bety(i)*signbx(i)
         r5_5(i) =  betz(i)/sqrt(rhohat(i)) 
         r5_6(i) = -bety(i)/sqrt(rhohat(i))
c
         r6_1(i) =  alpf(i)
         r6_2(i) =  alpf(i)*(vxhat(i)+cf(i))
         r6_3(i) =  alpf(i)*vyhat(i)-alps(i)*bety(i)*bx(i)
         r6_4(i) =  alpf(i)*vzhat(i)-alps(i)*betz(i)*bx(i)
         r6_5(i) =  alps(i)*bety(i)*cf(i)/sqrt(rhohat(i))
         r6_6(i) =  alps(i)*betz(i)*cf(i)/sqrt(rhohat(i))
 107  continue
c-----------------------------------------------------------------------
c  L1k(i+1/2), L2k(i+1/2), L3k(i+1/2), L4k(i+1/2), L5k(i+1/2), L6k(i+1/2)
c-----------------------------------------------------------------------
      do 108 i=-1,nd+1
         the1(i) = 2.*(alpf(i)**2*a**2+alps(i)**2*cf(i)**2)
         the2(i) = 2.*(alpf(i)**2*cf(i)*a+alps(i)**2*ca(i)*cs(i))
 108  continue
c
      do 109 i=-1,nd+1
         l1_1(i) = alpf(i)*a**2/the1(i)
     &            +( alpf(i)*a*vxhat(i)
     &              -alps(i)*cs(i)*(bety(i)*vyhat(i)+betz(i)*vzhat(i))
     &               *signbx(i))/the2(i)
         l1_2(i) =-alpf(i)*a/the2(i)
         l1_3(i) = alps(i)*bety(i)*cs(i)*signbx(i)/the2(i)
         l1_4(i) = alps(i)*betz(i)*cs(i)*signbx(i)/the2(i)
         l1_5(i) = alps(i)*bety(i)*cf(i)*sqrt(rhohat(i))/the1(i)
         l1_6(i) = alps(i)*betz(i)*cf(i)*sqrt(rhohat(i))/the1(i)
c
         l2_1(i) =-(betz(i)*vyhat(i)-bety(i)*vzhat(i))*signbx(i)/2.
         l2_2(i) = 0.
         l2_3(i) = betz(i)*signbx(i)/2.
         l2_4(i) =-bety(i)*signbx(i)/2.
         l2_5(i) = betz(i)*sqrt(rhohat(i))/2.
         l2_6(i) =-bety(i)*sqrt(rhohat(i))/2.
c
         l3_1(i) = alps(i)*cf(i)**2/the1(i)
     &            +( alps(i)*ca(i)*vxhat(i)
     &              +alpf(i)*cf(i)*(bety(i)*vyhat(i)+betz(i)*vzhat(i))
     &               *signbx(i))/the2(i)
         l3_2(i) =-alps(i)*ca(i)/the2(i)
         l3_3(i) =-alpf(i)*bety(i)*cf(i)*signbx(i)/the2(i)
         l3_4(i) =-alpf(i)*betz(i)*cf(i)*signbx(i)/the2(i)
         l3_5(i) =-alpf(i)*bety(i)*cf(i)*sqrt(rhohat(i))/the1(i)
         l3_6(i) =-alpf(i)*betz(i)*cf(i)*sqrt(rhohat(i))/the1(i)
c
         l4_1(i) = alps(i)*cf(i)**2/the1(i)
     &            -( alps(i)*ca(i)*vxhat(i)
     &              +alpf(i)*cf(i)*(bety(i)*vyhat(i)+betz(i)*vzhat(i))
     &               *signbx(i))/the2(i)
         l4_2(i) = alps(i)*ca(i)/the2(i)
         l4_3(i) = alpf(i)*bety(i)*cf(i)*signbx(i)/the2(i)
         l4_4(i) = alpf(i)*betz(i)*cf(i)*signbx(i)/the2(i)
         l4_5(i) =-alpf(i)*bety(i)*cf(i)*sqrt(rhohat(i))/the1(i)
         l4_6(i) =-alpf(i)*betz(i)*cf(i)*sqrt(rhohat(i))/the1(i)
c
         l5_1(i) = (betz(i)*vyhat(i)-bety(i)*vzhat(i))*signbx(i)/2.
         l5_2(i) = 0.
         l5_3(i) =-betz(i)*signbx(i)/2.
         l5_4(i) = bety(i)*signbx(i)/2.
         l5_5(i) = betz(i)*sqrt(rhohat(i))/2.
         l5_6(i) =-bety(i)*sqrt(rhohat(i))/2.
c
         l6_1(i) = alpf(i)*a**2/the1(i)
     &            +(-alpf(i)*a*vxhat(i)
     &              +alps(i)*cs(i)*(bety(i)*vyhat(i)+betz(i)*vzhat(i))
     &               *signbx(i))/the2(i)
         l6_2(i) = alpf(i)*a/the2(i)
         l6_3(i) =-alps(i)*bety(i)*cs(i)*signbx(i)/the2(i)
         l6_4(i) =-alps(i)*betz(i)*cs(i)*signbx(i)/the2(i)
         l6_5(i) = alps(i)*bety(i)*cf(i)*sqrt(rhohat(i))/the1(i)
         l6_6(i) = alps(i)*betz(i)*cf(i)*sqrt(rhohat(i))/the1(i)
 109  continue
c
      do 110 i=-1,nd+1
         if (by(i) .ne. 0.) then
            signbt = sign(1.,by(i))
         else
            signbt = sign(1.,bz(i))
         endif
c
         if (a .ge. ca(i)) then
            r3_1(i) = r3_1(i)*signbt
            r3_2(i) = r3_2(i)*signbt
            r3_3(i) = r3_3(i)*signbt
            r3_4(i) = r3_4(i)*signbt
            r3_5(i) = r3_5(i)*signbt
            r3_6(i) = r3_6(i)*signbt
            r4_1(i) = r4_1(i)*signbt
            r4_2(i) = r4_2(i)*signbt
            r4_3(i) = r4_3(i)*signbt
            r4_4(i) = r4_4(i)*signbt
            r4_5(i) = r4_5(i)*signbt
            r4_6(i) = r4_6(i)*signbt
c
            l3_1(i) = l3_1(i)*signbt
            l3_2(i) = l3_2(i)*signbt
            l3_3(i) = l3_3(i)*signbt
            l3_4(i) = l3_4(i)*signbt
            l3_5(i) = l3_5(i)*signbt
            l3_6(i) = l3_6(i)*signbt
            l4_1(i) = l4_1(i)*signbt
            l4_2(i) = l4_2(i)*signbt
            l4_3(i) = l4_3(i)*signbt
            l4_4(i) = l4_4(i)*signbt
            l4_5(i) = l4_5(i)*signbt
            l4_6(i) = l4_6(i)*signbt
         else
            r1_1(i) = r1_1(i)*signbt
            r1_2(i) = r1_2(i)*signbt
            r1_3(i) = r1_3(i)*signbt
            r1_4(i) = r1_4(i)*signbt
            r1_5(i) = r1_5(i)*signbt
            r1_6(i) = r1_6(i)*signbt
            r6_1(i) = r6_1(i)*signbt
            r6_2(i) = r6_2(i)*signbt
            r6_3(i) = r6_3(i)*signbt
            r6_4(i) = r6_4(i)*signbt
            r6_5(i) = r6_5(i)*signbt
            r6_6(i) = r6_6(i)*signbt
c
            l1_1(i) = l1_1(i)*signbt
            l1_2(i) = l1_2(i)*signbt
            l1_3(i) = l1_3(i)*signbt
            l1_4(i) = l1_4(i)*signbt
            l1_5(i) = l1_5(i)*signbt
            l1_6(i) = l1_6(i)*signbt
            l6_1(i) = l6_1(i)*signbt
            l6_2(i) = l6_2(i)*signbt
            l6_3(i) = l6_3(i)*signbt
            l6_4(i) = l6_4(i)*signbt
            l6_5(i) = l6_5(i)*signbt
            l6_6(i) = l6_6(i)*signbt
         endif
 110  continue
c-----------------------------------------------------------------------
c  alpk(i+1/2)
c-----------------------------------------------------------------------
      do 111 i=-1,nd+1
         alp1(i) = l1_1(i)*(qw1(i+1)-qw1(i))
     &            +l1_2(i)*(qw2(i+1)-qw2(i))
     &            +l1_3(i)*(qw3(i+1)-qw3(i))
     &            +l1_4(i)*(qw4(i+1)-qw4(i))
     &            +l1_5(i)*(qw6(i+1)-qw6(i))
     &            +l1_6(i)*(qw7(i+1)-qw7(i))
         alp2(i) = l2_1(i)*(qw1(i+1)-qw1(i))
     &            +l2_2(i)*(qw2(i+1)-qw2(i))
     &            +l2_3(i)*(qw3(i+1)-qw3(i))
     &            +l2_4(i)*(qw4(i+1)-qw4(i))
     &            +l2_5(i)*(qw6(i+1)-qw6(i))
     &            +l2_6(i)*(qw7(i+1)-qw7(i))
         alp3(i) = l3_1(i)*(qw1(i+1)-qw1(i))
     &            +l3_2(i)*(qw2(i+1)-qw2(i))
     &            +l3_3(i)*(qw3(i+1)-qw3(i))
     &            +l3_4(i)*(qw4(i+1)-qw4(i))
     &            +l3_5(i)*(qw6(i+1)-qw6(i))
     &            +l3_6(i)*(qw7(i+1)-qw7(i))
         alp4(i) = l4_1(i)*(qw1(i+1)-qw1(i))
     &            +l4_2(i)*(qw2(i+1)-qw2(i))
     &            +l4_3(i)*(qw3(i+1)-qw3(i))
     &            +l4_4(i)*(qw4(i+1)-qw4(i))
     &            +l4_5(i)*(qw6(i+1)-qw6(i))
     &            +l4_6(i)*(qw7(i+1)-qw7(i))
         alp5(i) = l5_1(i)*(qw1(i+1)-qw1(i))
     &            +l5_2(i)*(qw2(i+1)-qw2(i))
     &            +l5_3(i)*(qw3(i+1)-qw3(i))
     &            +l5_4(i)*(qw4(i+1)-qw4(i))
     &            +l5_5(i)*(qw6(i+1)-qw6(i))
     &            +l5_6(i)*(qw7(i+1)-qw7(i))
         alp6(i) = l6_1(i)*(qw1(i+1)-qw1(i))
     &            +l6_2(i)*(qw2(i+1)-qw2(i))
     &            +l6_3(i)*(qw3(i+1)-qw3(i))
     &            +l6_4(i)*(qw4(i+1)-qw4(i))
     &            +l6_5(i)*(qw6(i+1)-qw6(i))
     &            +l6_6(i)*(qw7(i+1)-qw7(i))
 111     continue
c-----------------------------------------------------------------------
c  ~gk(i+1/2)
c-----------------------------------------------------------------------
      do 112 i=-1,nd+1
         if (dtdl*abs(a1(i)).ge.2.*eps1) then
           gt1(i) =(dtdl*abs(a1(i))-(dtdl*a1(i))**2)
     &                *0.5*alp1(i)
         else
           gt1(i) =((dtdl*a1(i))**2*0.25/eps1+eps1-(dtdl*a1(i))**2)
     &                *0.5*alp1(i)
         endif
         if (dtdl*abs(a2(i)).ge.2.*eps2) then
           gt2(i) =(dtdl*abs(a2(i))-(dtdl*a2(i))**2)
     &                *0.5*alp2(i)
         else
           gt2(i) =((dtdl*a2(i))**2*0.25/eps2+eps2-(dtdl*a2(i))**2)
     &                *0.5*alp2(i)
         endif
         if (dtdl*abs(a3(i)).ge.2.*eps3) then
           gt3(i) =(dtdl*abs(a3(i))-(dtdl*a3(i))**2)
     &                *0.5*alp3(i)
         else
           gt3(i) =((dtdl*a3(i))**2*0.25/eps3+eps3-(dtdl*a3(i))**2)
     &                *0.5*alp3(i)
         endif
         if (dtdl*abs(a4(i)).ge.2.*eps3) then
           gt4(i) =(dtdl*abs(a4(i))-(dtdl*a4(i))**2)
     &                *0.5*alp4(i)
         else
           gt4(i) =((dtdl*a4(i))**2*0.25/eps3+eps3-(dtdl*a4(i))**2)
     &                *0.5*alp4(i)
         endif
         if (dtdl*abs(a5(i)).ge.2.*eps2) then
           gt5(i) =(dtdl*abs(a5(i))-(dtdl*a5(i))**2)
     &                *0.5*alp5(i)
         else
           gt5(i) =((dtdl*a5(i))**2*0.25/eps2+eps2-(dtdl*a5(i))**2)
     &                *0.5*alp5(i)
         endif
         if (dtdl*abs(a6(i)).ge.2.*eps1) then
           gt6(i) =(dtdl*abs(a6(i))-(dtdl*a6(i))**2)
     &                *0.5*alp6(i)
         else
           gt6(i) =((dtdl*a6(i))**2*0.25/eps1+eps1-(dtdl*a6(i))**2)
     &                *0.5*alp6(i)
         endif
 112  continue
c-----------------------------------------------------------------------
c  gk(i)
c-----------------------------------------------------------------------
      do 113 i=0,nd+1
         g1(i) = sign(1.0,gt1(i))
     &          *max(0.0,min(abs(gt1(i)),sign(1.0,gt1(i))*gt1(i-1)))
         g2(i) = sign(1.0,gt2(i))    
     &          *max(0.0,min(abs(gt2(i)),sign(1.0,gt2(i))*gt2(i-1)))
         g3(i) = sign(1.0,gt3(i))
     &          *max(0.0,min(abs(gt3(i)),sign(1.0,gt3(i))*gt3(i-1)))
         g4(i) = sign(1.0,gt4(i))
     &          *max(0.0,min(abs(gt4(i)),sign(1.0,gt4(i))*gt4(i-1)))
         g5(i) = sign(1.0,gt5(i))
     &          *max(0.0,min(abs(gt5(i)),sign(1.0,gt5(i))*gt5(i-1)))
         g6(i) = sign(1.0,gt6(i))
     &          *max(0.0,min(abs(gt6(i)),sign(1.0,gt6(i))*gt6(i-1)))
 113  continue
c-----------------------------------------------------------------------
c  gamk(i+1/2)
c-----------------------------------------------------------------------
      do 114 i=0,nd
         if (abs(alp1(i)).ge.1.e-30) then
            gam1(i) = (g1(i+1)-g1(i))/alp1(i)
         else
            gam1(i) = 0.
         endif
         if (abs(alp2(i)).ge.1.e-30) then
            gam2(i) = (g2(i+1)-g2(i))/alp2(i)
         else
            gam2(i) = 0.
         endif
         if (abs(alp3(i)).ge.1.e-30) then
            gam3(i) = (g3(i+1)-g3(i))/alp3(i)
         else
            gam3(i) = 0.
         endif
         if (abs(alp4(i)).ge.1.e-30) then
            gam4(i) = (g4(i+1)-g4(i))/alp4(i)
         else
            gam4(i) = 0.
         endif
         if (abs(alp5(i)).ge.1.e-30) then
            gam5(i) = (g5(i+1)-g5(i))/alp5(i)
         else
            gam5(i) = 0.
         endif
         if (abs(alp6(i)).ge.1.e-30) then
            gam6(i) = (g6(i+1)-g6(i))/alp6(i)
         else
            gam6(i) = 0.
         endif
 114  continue
c-----------------------------------------------------------------------
c  betk(i+1/2)
c-----------------------------------------------------------------------
      do 115 i=0,nd
         if (abs(dtdl*a1(i)+gam1(i)).ge.2.0*eps1) then
           bet1(i) = abs(dtdl*a1(i)+gam1(i))*alp1(i)
     &              - (g1(i)+g1(i+1))
         else
           bet1(i) = ((dtdl*a1(i)+gam1(i))**2*0.25/eps1+eps1)*alp1(i) 
     &              - (g1(i)+g1(i+1))
         endif
         if (abs(dtdl*a2(i)+gam2(i)).ge.2.0*eps2) then
           bet2(i) = abs(dtdl*a2(i)+gam2(i))*alp2(i)
     &              - (g2(i)+g2(i+1))
         else
           bet2(i) = ((dtdl*a2(i)+gam2(i))**2*0.25/eps2+eps2)*alp2(i) 
     &              - (g2(i)+g2(i+1))
         endif
         if (abs(dtdl*a3(i)+gam3(i)).ge.2.0*eps3) then
           bet3(i) = abs(dtdl*a3(i)+gam3(i))*alp3(i)
     &              - (g3(i)+g3(i+1))
         else
           bet3(i) = ((dtdl*a3(i)+gam3(i))**2*0.25/eps3+eps3)*alp3(i) 
     &              - (g3(i)+g3(i+1))
         endif
         if (abs(dtdl*a4(i)+gam4(i)).ge.2.0*eps3) then
           bet4(i) = abs(dtdl*a4(i)+gam4(i))*alp4(i)
     &              - (g4(i)+g4(i+1))
         else
           bet4(i) = ((dtdl*a4(i)+gam4(i))**2*0.25/eps3+eps3)*alp4(i) 
     &              - (g4(i)+g4(i+1))
         endif
         if (abs(dtdl*a5(i)+gam5(i)).ge.2.0*eps2) then
           bet5(i) = abs(dtdl*a5(i)+gam5(i))*alp5(i)
     &              - (g5(i)+g5(i+1))
         else
           bet5(i) = ((dtdl*a5(i)+gam5(i))**2*0.25/eps2+eps2)*alp5(i) 
     &              - (g5(i)+g5(i+1))
         endif
         if (abs(dtdl*a6(i)+gam6(i)).ge.2.0*eps1) then
           bet6(i) = abs(dtdl*a6(i)+gam6(i))*alp6(i)
     &              -(g6(i)+g6(i+1))
         else
           bet6(i) = ((dtdl*a6(i)+gam6(i))**2*0.25/eps1+eps1)*alp6(i) 
     &              - (g6(i)+g6(i+1))
         endif
 115  continue
c-----------------------------------------------------------------------
c  -f(i+1/2)
c-----------------------------------------------------------------------
      do 116 i=0,nd
         fbar1(i) = (f1(i)+f1(i+1))*0.5
         fbar2(i) = (f2(i)+f2(i+1))*0.5
         fbar3(i) = (f3(i)+f3(i+1))*0.5
         fbar4(i) = (f4(i)+f4(i+1))*0.5
         fbar5(i) = (f5(i)+f5(i+1))*0.5
         fbar6(i) = (f6(i)+f6(i+1))*0.5
c
         fbar1(i) = fbar1(i) - ( bet1(i)*r1_1(i)
     &                          +bet2(i)*r2_1(i)
     &                          +bet3(i)*r3_1(i)
     &                          +bet4(i)*r4_1(i)
     &                          +bet5(i)*r5_1(i)
     &                          +bet6(i)*r6_1(i) )*0.5/dtdl
         fbar2(i) = fbar2(i) - ( bet1(i)*r1_2(i)
     &                          +bet2(i)*r2_2(i)
     &                          +bet3(i)*r3_2(i)
     &                          +bet4(i)*r4_2(i)
     &                          +bet5(i)*r5_2(i)
     &                          +bet6(i)*r6_2(i) )*0.5/dtdl
         fbar3(i) = fbar3(i) - ( bet1(i)*r1_3(i)
     &                          +bet2(i)*r2_3(i)
     &                          +bet3(i)*r3_3(i)
     &                          +bet4(i)*r4_3(i)
     &                          +bet5(i)*r5_3(i)
     &                          +bet6(i)*r6_3(i) )*0.5/dtdl
         fbar4(i) = fbar4(i) - ( bet1(i)*r1_4(i)
     &                          +bet2(i)*r2_4(i)
     &                          +bet3(i)*r3_4(i)
     &                          +bet4(i)*r4_4(i)
     &                          +bet5(i)*r5_4(i)
     &                          +bet6(i)*r6_4(i) )*0.5/dtdl
         fbar5(i) = fbar5(i) - ( bet1(i)*r1_5(i)
     &                          +bet2(i)*r2_5(i)
     &                          +bet3(i)*r3_5(i)
     &                          +bet4(i)*r4_5(i)
     &                          +bet5(i)*r5_5(i)
     &                          +bet6(i)*r6_5(i) )*0.5/dtdl
         fbar6(i) = fbar6(i) - ( bet1(i)*r1_6(i)
     &                          +bet2(i)*r2_6(i)
     &                          +bet3(i)*r3_6(i)
     &                          +bet4(i)*r4_6(i)
     &                          +bet5(i)*r5_6(i)
     &                          +bet6(i)*r6_6(i) )*0.5/dtdl
 116  continue
c-----------------------------------------------------------------------
c  update
c-----------------------------------------------------------------------
      do 117 i=1,nd
         qw1(i) = qw1(i) - dtdl*(fbar1(i)-fbar1(i-1))
         qw2(i) = qw2(i) - dtdl*(fbar2(i)-fbar2(i-1))
         qw3(i) = qw3(i) - dtdl*(fbar3(i)-fbar3(i-1))
         qw4(i) = qw4(i) - dtdl*(fbar4(i)-fbar4(i-1))
         qw6(i) = qw6(i) - dtdl*(fbar5(i)-fbar5(i-1))
         qw7(i) = qw7(i) - dtdl*(fbar6(i)-fbar6(i-1))
 117  continue
c-----------------------------------------------------------------------
c  end
c-----------------------------------------------------------------------
      return
      end
