      subroutine out
c-----------------------------------------------------------------------
c  write output
c-----------------------------------------------------------------------
      implicit none
c
      include 'mpif.h'
      include 'common.inc'
c
      integer i, j, k
      real  vxrmsp, vyrmsp, vzrmsp
      real  vxrms,  vyrms,  vzrms 
      real  Eip, Ehp, Ekp, Emp, Egp
      real  Ei,  Eh,  Ek,  Em,  Eg,  Et
      real  divb0, divb0maxp, divb0max
c-----------------------------------------------------------------------
c  vrms
c-----------------------------------------------------------------------
      vxrmsp = 0.
      vyrmsp = 0.
      vzrmsp = 0.
c
      divb0maxp = -1.e30
c
      Eip  = 0.
      Ehp  = 0.
      Ekp  = 0.
      Emp  = 0.
      Egp  = 0.
c
      do 101 k=1,nzp
      do 101 j=1,ny
      do 101 i=1,nx
c
         vxrmsp = vxrmsp  + (q2(i,j,k)/q1(i,j,k))**2
         vyrmsp = vyrmsp  + (q3(i,j,k)/q1(i,j,k))**2
         vzrmsp = vzrmsp  + (q4(i,j,k)/q1(i,j,k))**2
c
         Eip = Eip + q1(i,j,k)
         Ehp = Ehp + q1(i,j,k)*log(q1(i,j,k))  
         Ekp = Ekp + (q2(i,j,k)**2+q3(i,j,k)**2+q4(i,j,k)**2)/q1(i,j,k)
         Emp = Emp + q5(i,j,k)**2+q6(i,j,k)**2+q7(i,j,k)**2
         Egp = Egp + q1(i,j,k)*y(j)
c
         divb0 = (q5(i+1,j,k)-q5(i-1,j,k)+
     &            q6(i,j+1,k)-q6(i,j-1,k)+
     &            q7(i,j,k+1)-q7(i,j,k-1))/2.
         divb0maxp = max(divb0maxp,abs(divb0))
c
 101  continue
c
      call MPI_BARRIER (MPI_COMM_WORLD,err)
c
      call MPI_REDUCE (vxrmsp,vxrms,1,MPI_REAL,
     &                 MPI_SUM,master,MPI_COMM_WORLD,err)
      call MPI_REDUCE (vyrmsp,vyrms,1,MPI_REAL,
     &                 MPI_SUM,master,MPI_COMM_WORLD,err)
      call MPI_REDUCE (vzrmsp,vzrms,1,MPI_REAL,
     &                 MPI_SUM,master,MPI_COMM_WORLD,err)
      call MPI_REDUCE (Eip,Ei,1,MPI_REAL,
     &                 MPI_SUM,master,MPI_COMM_WORLD,err)
      call MPI_REDUCE (Ehp,Eh,1,MPI_REAL,
     &                 MPI_SUM,master,MPI_COMM_WORLD,err)
      call MPI_REDUCE (Ekp,Ek,1,MPI_REAL,
     &                 MPI_SUM,master,MPI_COMM_WORLD,err)
      call MPI_REDUCE (Emp,Em,1,MPI_REAL,
     &                 MPI_SUM,master,MPI_COMM_WORLD,err)
      call MPI_REDUCE (Egp,Eg,1,MPI_REAL,
     &                 MPI_SUM,master,MPI_COMM_WORLD,err)
      call MPI_REDUCE (divb0maxp,divb0max,1,MPI_REAL,
     &                 MPI_MAX,master,MPI_COMM_WORLD,err)
c
      if (pi.eq.master) then
c
         vxrms = sqrt(vxrms/real(nx*ny*nz))
         vyrms = sqrt(vyrms/real(nx*ny*nz))
         vzrms = sqrt(vzrms/real(nx*ny*nz))
c
         Ei = 1.5*Ei / Ei0
         Eh = Eh / Ei0
         Ek = 0.5*Ek / Ei0
         Em = alpha*Em/sqrt(2.*alpha) / Ei0
         Eg = (1.+alpha)*Eg / Ei0
c
         Et = Eh + Ek + Em + Eg 

         write(11,201) t, vxrms, vyrms, vzrms
         write(12,201) t, Ei, Eh, Ek, Em, Eg, Et, divb0max
      endif
 201  format (1p8e14.6)
c
      call MPI_BARRIER (MPI_COMM_WORLD,err)
c-----------------------------------------------------------------------
c  end
c-----------------------------------------------------------------------
      return
      end
